package com.mistdev.notificationscheduler

import java.util.*

object NotificationDateBuilder {

    fun buildEndDate(details: NotificationDetails, now: Calendar) : Calendar {
        return (now.clone() as Calendar).apply {
            //Dia de vencimento nesse mês já foi. Avançar para o mês que vem.
            if(details.dueDay < get(Calendar.DAY_OF_MONTH)) {
                add(Calendar.MONTH, 1)
            }

            //Verificar se o dueDay não ultrapassa o máximo de dias nesse mês. Tratar de acordo.
            val maxDayOfMonth = getActualMaximum(Calendar.DAY_OF_MONTH)
            if(details.dueDay > maxDayOfMonth) {
                set(Calendar.DAY_OF_MONTH, maxDayOfMonth)

            } else {
                set(Calendar.DAY_OF_MONTH, details.dueDay)
            }
        }
    }

    fun buildStartDate(details: NotificationDetails, endDate: Calendar) : Calendar {
        return (endDate.clone() as Calendar).apply {
            add(Calendar.DAY_OF_MONTH, - details.daysToNotify)
        }
    }

    fun buildNextNotificationStartDate(details: NotificationDetails, now: Calendar, alarmHour: Int) : Calendar {
        val endDate = buildEndDate(details, now)
        val startDate = buildStartDate(details, endDate)

        if(now.after(endDate)) {
            startDate.add(Calendar.MONTH, 1)
        }

        return startDate.apply {
            set(Calendar.HOUR_OF_DAY, alarmHour)
        }
    }
}