package com.mistdev.notificationscheduler

import android.content.Context
import io.flutter.plugin.common.MethodCall

data class NotificationDetails(
        val id: Int,
        val title: String,
        val message: String,
        val dueDay: Int,
        val daysToNotify: Int,
        val smallIconId: Int
) {

    companion object {
        private const val KEY_ID = "id"
        private const val KEY_TITLE = "title"
        private const val KEY_MESSAGE = "message"
        private const val KEY_DUE_DAY = "dueDay"
        private const val KEY_DAYS_TO_NOTIFY = "daysToNotify"
        private const val KEY_ICON = "icon"
        private const val KEY_ICON_TYPE = "iconType"

        private const val DEFAULT_ICON = "ic_launcher"
        private const val DEFAULT_ICON_TYPE = "mipmap"

        @JvmStatic
        fun build(context: Context, call: MethodCall) : NotificationDetails {
            val id = call.argument<Int>(KEY_ID)!!
            val title = call.argument<String>(KEY_TITLE)!!
            val message = call.argument<String>(KEY_MESSAGE)!!
            val dueDay = call.argument<Int>(KEY_DUE_DAY)!!
            val daysToNotify = call.argument<Int>(KEY_DAYS_TO_NOTIFY)!!

            val defaultIcon = call.argument<String>(KEY_ICON) ?: DEFAULT_ICON
            val defaultIconType = call.argument<String>(KEY_ICON_TYPE) ?: DEFAULT_ICON_TYPE
            val defaultIconResourceId = context.resources.getIdentifier(defaultIcon, defaultIconType, context.packageName)

            return NotificationDetails(id, title, message, dueDay, daysToNotify, defaultIconResourceId)
        }
    }
}