package com.mistdev.notificationscheduler

import org.junit.Test
import java.util.*

class CalculateNotificationStartDateTests {

    @Test
    fun testCalculateNotificationStartDate() {
        val details = NotificationDetails(0, "Conta", "Pagar conta", 10, 5, 0)
        val calendar = Calendar.getInstance().apply {
            set(2019, Calendar.JANUARY, 5)
        }

        val startDate = NotificationDateBuilder.buildNextNotificationStartDate(details, calendar, 10)

        assert(startDate.get(Calendar.MONTH) == Calendar.JANUARY && startDate.get(Calendar.DAY_OF_MONTH) == 5)
    }

    @Test
    fun testCalculateNotificationStartDate_nextMonth() {
        val details = NotificationDetails(0, "Conta", "Pagar conta", 29, 5, 0)
        val calendar = Calendar.getInstance().apply {
            set(2019, Calendar.JANUARY, 30)
        }

        val startDate = NotificationDateBuilder.buildNextNotificationStartDate(details, calendar, 10)

        assert(startDate.get(Calendar.MONTH) == Calendar.FEBRUARY && startDate.get(Calendar.DAY_OF_MONTH) == 23)
    }

    @Test
    fun testCalculateNotificationStartDate_february() {
        val details = NotificationDetails(0, "Conta", "Pagar conta", 30, 5, 0)
        val calendar = Calendar.getInstance().apply {
            set(2019, Calendar.FEBRUARY, 28)
        }

        val startDate = NotificationDateBuilder.buildNextNotificationStartDate(details, calendar, 10)

        assert(startDate.get(Calendar.MONTH) == Calendar.FEBRUARY && startDate.get(Calendar.DAY_OF_MONTH) == 23)
    }

    @Test
    fun testCalculateNotificationStartDate_sameDay() {
        val details = NotificationDetails(0, "Conta", "Pagar conta", 30, 5, 0)
        val calendar = Calendar.getInstance().apply {
            set(2019, Calendar.JANUARY, 30)
        }

        val startDate = NotificationDateBuilder.buildNextNotificationStartDate(details, calendar, 10)

        assert(startDate.get(Calendar.MONTH) == Calendar.JANUARY && startDate.get(Calendar.DAY_OF_MONTH) == 25)
    }
}