import 'dart:async';
import 'package:flutter/services.dart';
import 'package:notification_scheduler/notification_details.dart';

class NotificationScheduler {
  static const MethodChannel _channel = const MethodChannel('com.mistdev/notification_scheduler');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<bool> scheduleNotification(NotificationDetails details) async {
    final bool isScheduled = await _channel.invokeMethod('scheduleNotification', details.toArguments());
    return isScheduled;
  }

  static Future<bool> cancelNotification() async {
  	final bool isCanceled = await _channel.invokeMethod('cancelNotification');
  	return isCanceled;
	}
}
